"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createWalkthrough = void 0;
const amplify_cli_core_1 = require("amplify-cli-core");
const path = __importStar(require("path"));
const templateFileName = 'amplify-console-notification-cloudformation-template.json.ejs';
/**
 * Starting point for CLI walkthrough that generates a Amplify Console Notification
 * @param context The Amplify Context object
 * @param category The resource category (should always be 'consolenotification')
 * @param options The options for Amplify Console Notification
 */
async function createWalkthrough(context, category, options) {
    const functionName = await addNewLambdaFunction(context);
    options.functionName = functionName;
    await copyCfnTemplate(context, category, options);
    const backendConfigs = {
        service: options.service,
        providerPlugin: 'awscloudformation',
        dependsOn: [
            {
                category: "function",
                resourceName: functionName,
                attributes: [
                    "Arn"
                ]
            }
        ],
    };
    await context.amplify.updateamplifyMetaAfterResourceAdd(category, 'slack', backendConfigs);
}
exports.createWalkthrough = createWalkthrough;
function copyCfnTemplate(context, category, options) {
    const { amplify } = context;
    // @ts-ignore
    const targetDir = amplify.pathManager.getBackendDirPath();
    const pluginDir = path.join(__dirname, '..', '..', '..', '..');
    const copyJobs = [
        {
            dir: pluginDir,
            template: `resources/awscloudformation/cloudformation-templates/${templateFileName}`,
            target: `${targetDir}/${category}/slack/slack-cloudformation-template.json`,
            paramsFile: path.join(targetDir, category, 'slack', 'parameters.json'),
        },
    ];
    const params = {
        appId: getAppId(context)
    };
    // copy over the files
    // @ts-ignore
    return context.amplify.copyBatch(context, copyJobs, options, false, params);
}
function getAppId(context) {
    const meta = context.amplify.getProjectMeta();
    if (meta.providers && meta.providers.awscloudformation) {
        return meta.providers.awscloudformation.AmplifyAppId;
    }
}
async function addNewLambdaFunction(context) {
    const params = {
        defaultRuntime: 'nodejs',
        template: "webhook",
    };
    const resourceName = await context.amplify.invokePluginMethod(context, amplify_cli_core_1.AmplifyCategories.FUNCTION, undefined, 'add', [
        context,
        'awscloudformation',
        amplify_cli_core_1.AmplifySupportedService.LAMBDA,
        params,
    ]);
    context.print.success(`Successfully added resource ${resourceName} locally`);
    return resourceName;
}
//# sourceMappingURL=amplify-console-notification-walkthrough.js.map